2009-08-02 Bruno Haible <bruno@clisp.org>
Paolo Bonzini <bonzini@gnu.org>
+ Tests for module 'pipe-filter-ii'.
+ * modules/pipe-filter-ii-tests: New file.
+ * tests/test-pipe-filter-ii1.sh: New file.
+ * tests/test-pipe-filter-ii1.c: New file.
+ * tests/test-pipe-filter-ii2.sh: New file.
+ * tests/test-pipe-filter-ii2-main.c: New file.
+ * tests/test-pipe-filter-ii2-child.c: New file.
+
New module 'pipe-filter-ii'.
* lib/pipe-filter.h: New file.
* lib/pipe-filter-ii.c: New file.
--- /dev/null
+Files:
+tests/test-pipe-filter-ii1.sh
+tests/test-pipe-filter-ii1.c
+tests/test-vasnprintf-posix.c
+tests/test-pipe-filter-ii2.sh
+tests/test-pipe-filter-ii2-main.c
+tests/test-pipe-filter-ii2-child.c
+
+Depends-on:
+binary-io
+c-ctype
+read-file
+full-write
+progname
+
+configure.ac:
+
+Makefile.am:
+TESTS += test-pipe-filter-ii1.sh test-pipe-filter-ii2.sh
+TESTS_ENVIRONMENT += EXEEXT='@EXEEXT@' srcdir='$(srcdir)'
+check_PROGRAMS += test-pipe-filter-ii1 test-pipe-filter-ii2-main test-pipe-filter-ii2-child
--- /dev/null
+/* Test of filtering of data through a subprocess.
+ Copyright (C) 2009 Free Software Foundation, Inc.
+ Written by Bruno Haible <haible@clisp.cons.org>, 2009.
+
+ This program is free software: you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 3 of the License, or
+ (at your option) any later version.
+
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License
+ along with this program. If not, see <http://www.gnu.org/licenses/>. */
+
+#include <config.h>
+
+#include "pipe-filter.h"
+
+#include <stdio.h>
+#include <stdlib.h>
+
+#include "binary-io.h"
+#include "c-ctype.h"
+#include "read-file.h"
+#include "progname.h"
+
+#define ASSERT(expr) \
+ do \
+ { \
+ if (!(expr)) \
+ { \
+ fprintf (stderr, "%s:%d: assertion failed\n", __FILE__, __LINE__); \
+ fflush (stderr); \
+ abort (); \
+ } \
+ } \
+ while (0)
+
+
+/* Pipe a text file through 'tr a-z A-Z', which converts ASCII characters from
+ lower case to upper case. */
+
+struct locals
+{
+ const char *input;
+ size_t size;
+ size_t nwritten;
+ size_t nread;
+ char buf[19];
+};
+
+static const void *
+prepare_write (size_t *num_bytes_p, void *private_data)
+{
+ struct locals *l = (struct locals *) private_data;
+ if (l->nwritten < l->size)
+ {
+ *num_bytes_p = l->size - l->nwritten;
+ return l->input + l->nwritten;
+ }
+ else
+ return NULL;
+}
+
+static void
+done_write (void *data_written, size_t num_bytes_written, void *private_data)
+{
+ struct locals *l = (struct locals *) private_data;
+ l->nwritten += num_bytes_written;
+}
+
+static void *
+prepare_read (size_t *num_bytes_p, void *private_data)
+{
+ struct locals *l = (struct locals *) private_data;
+ *num_bytes_p = sizeof (l->buf);
+ return l->buf;
+}
+
+static void
+done_read (void *data_read, size_t num_bytes_read, void *private_data)
+{
+ struct locals *l = (struct locals *) private_data;
+ const char *p = l->input + l->nread;
+ const char *q = (const char *) data_read;
+ size_t i;
+
+ for (i = 0; i < num_bytes_read; i++, q++)
+ {
+ /* Handle conversion NL -> CRLF possibly done by the child process. */
+ if (!(O_BINARY && *q == '\r'))
+ {
+ char orig = *p;
+ char expected = c_toupper (orig);
+ ASSERT (*q == expected);
+ p++;
+ }
+ }
+ l->nread = p - l->input;
+}
+
+int
+main (int argc, char *argv[])
+{
+ const char *input_filename;
+ size_t input_size;
+ char *input;
+
+ set_program_name (argv[0]);
+
+ ASSERT (argc == 2);
+
+ /* Read some text from a file. */
+ input_filename = argv[1];
+ input = read_binary_file (input_filename, &input_size);
+ ASSERT (input != NULL);
+
+ /* Convert it to uppercase, line by line. */
+ {
+ const char *argv[4];
+ struct locals l;
+ int result;
+
+ l.input = input;
+ l.size = input_size;
+ l.nwritten = 0;
+ l.nread = 0;
+
+ argv[0] = "tr";
+ argv[1] = "a-z";
+ argv[2] = "A-Z";
+ argv[3] = NULL;
+
+ result = pipe_filter_ii_execute ("tr", "tr", argv, false, true,
+ prepare_write, done_write,
+ prepare_read, done_read,
+ &l);
+ ASSERT (result == 0);
+ ASSERT (l.nwritten == input_size);
+ ASSERT (l.nread == input_size);
+ }
+
+ return 0;
+}
--- /dev/null
+#!/bin/sh
+# A small file.
+./test-pipe-filter-ii1${EXEEXT} "${srcdir}/test-pipe-filter-ii1.sh" || exit 1
+# A medium-sized file.
+./test-pipe-filter-ii1${EXEEXT} "${srcdir}/test-pipe-filter-ii1.c" || exit 1
+# A large file.
+./test-pipe-filter-ii1${EXEEXT} "${srcdir}/test-vasnprintf-posix.c" || exit 1
--- /dev/null
+/* Child program invoked by test-pipe-filter-ii2-main.
+
+ Copyright (C) 2009 Free Software Foundation, Inc.
+ Written by Paolo Bonzini <bonzini@gnu.org>, 2009.
+
+ This program is free software: you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 3 of the License, or
+ (at your option) any later version.
+
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License
+ along with this program. If not, see <http://www.gnu.org/licenses/>. */
+
+#include <config.h>
+
+#include <stdio.h>
+#include <stdlib.h>
+
+int
+main ()
+{
+ /* Repeatedly: Read two integers i and j, then output all integers in the
+ range i..j, one per line. */
+ for (;;)
+ {
+ int i, j;
+
+ if (scanf (" %d", &i) != 1)
+ break;
+ if (scanf (" %d", &j) != 1)
+ break;
+ if (j == -1)
+ exit (i);
+ while (i <= j)
+ printf ("abcdefghijklmnopqrstuvwxyz%d\n", i++);
+ }
+ exit (0);
+}
--- /dev/null
+/* Test harness for pipe-filter-ii.
+
+ Copyright (C) 2009 Free Software Foundation, Inc.
+ Written by Paolo Bonzini <bonzini@gnu.org>, 2009.
+
+ This program is free software: you can redistribute it and/or modify
+ it under the terms of the GNU General Public License as published by
+ the Free Software Foundation; either version 3 of the License, or
+ (at your option) any later version.
+
+ This program is distributed in the hope that it will be useful,
+ but WITHOUT ANY WARRANTY; without even the implied warranty of
+ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+ GNU General Public License for more details.
+
+ You should have received a copy of the GNU General Public License
+ along with this program. If not, see <http://www.gnu.org/licenses/>. */
+
+#include <config.h>
+
+#include "pipe-filter.h"
+
+#include <stdio.h>
+#include <errno.h>
+#include <unistd.h>
+#include <string.h>
+#include <signal.h>
+
+#include "full-write.h"
+#include "progname.h"
+
+#define ASSERT(expr) \
+ do \
+ { \
+ if (!(expr)) \
+ { \
+ fprintf (stderr, "%s:%d: assertion failed\n", __FILE__, __LINE__); \
+ fflush (stderr); \
+ abort (); \
+ } \
+ } \
+ while (0)
+
+struct locals
+{
+ const char *input;
+ size_t size;
+ size_t nwritten;
+ size_t nread;
+ char buf[5];
+};
+
+static const void *
+prepare_write (size_t *num_bytes_p, void *private_data)
+{
+ struct locals *l = (struct locals *) private_data;
+ if (l->nwritten < l->size)
+ {
+ *num_bytes_p = l->size - l->nwritten;
+ return l->input + l->nwritten;
+ }
+ else
+ return NULL;
+}
+
+static void
+done_write (void *data_written, size_t num_bytes_written, void *private_data)
+{
+ struct locals *l = (struct locals *) private_data;
+ l->nwritten += num_bytes_written;
+}
+
+static void *
+prepare_read (size_t *num_bytes_p, void *private_data)
+{
+ struct locals *l = (struct locals *) private_data;
+ *num_bytes_p = sizeof (l->buf);
+ return l->buf;
+}
+
+/* Callback that ignores the data that has been read. */
+
+static void
+ignore_done_read (void *data_read, size_t num_bytes_read, void *private_data)
+{
+}
+
+/* Callback that outputs the data that has been read. */
+
+static void
+output_done_read (void *data_read, size_t num_bytes_read, void *private_data)
+{
+ full_write (STDOUT_FILENO, data_read, num_bytes_read);
+}
+
+int
+main (int argc, char **argv)
+{
+ const char *path[] = { NULL, NULL };
+
+ set_program_name (argv[0]);
+
+ ASSERT (argc == 2);
+
+ /* Test writing to a nonexistent program traps sooner or later. */
+ {
+ struct locals l;
+ int rc;
+
+ l.input = "";
+ l.size = 1;
+ l.nwritten = 0;
+ l.nread = 0;
+ path[0] = "/nonexistent/blah";
+ rc = pipe_filter_ii_execute ("pipe-filter-test", path[0], path, true, false,
+ prepare_write, done_write,
+ prepare_read, ignore_done_read,
+ &l);
+ ASSERT (rc == 127 || rc == -1);
+ printf ("Test 1 passed.\n");
+ fflush (stdout);
+ }
+
+ /* Test returning the exit status. */
+ {
+ struct locals l;
+ int rc;
+
+ l.input = "1 -1";
+ l.size = strlen (l.input);
+ l.nwritten = 0;
+ l.nread = 0;
+ path[0] = argv[1];
+ rc = pipe_filter_ii_execute ("pipe-filter-test", path[0], path, false, false,
+ prepare_write, done_write,
+ prepare_read, ignore_done_read,
+ &l);
+ ASSERT (rc == 1);
+ printf ("Test 2 passed.\n");
+ fflush (stdout);
+ }
+
+ /* Now test asynchronous I/O. */
+ {
+ struct locals l;
+ int rc;
+
+ l.input = "1 50\n51\n100";
+ l.size = strlen (l.input);
+ l.nwritten = 0;
+ l.nread = 0;
+ path[0] = argv[1];
+ rc = pipe_filter_ii_execute ("pipe-filter-test", path[0], path, false, true,
+ prepare_write, done_write,
+ prepare_read, output_done_read,
+ &l);
+ ASSERT (rc == 0);
+ printf ("Test 3 passed.\n");
+ fflush (stdout);
+ }
+
+ return 0;
+}
--- /dev/null
+#! /bin/sh
+
+# pipe-filter test driver.
+#
+# Copyright (C) 2009 Free Software Foundation, Inc.
+# Written by Paolo Bonzini <bonzini@gnu.org>, 2009.
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>. */
+
+./test-pipe-filter-ii2-main${EXEEXT} ./test-pipe-filter-ii2-child${EXEEXT} | {
+ set -e
+ read a && test "$a" = "Test 1 passed."
+ read a && test "$a" = "Test 2 passed."
+ i=1
+ while test $i -le 100; do
+ read a && test "$a" = "abcdefghijklmnopqrstuvwxyz$i"
+ i=`expr $i + 1`
+ done
+ read a && test "$a" = "Test 3 passed."
+}